// #########################################################################################################
// Author:	Henk Reints
// Date:	14-FEB-2009
// Purpose:	JavaScript functions for handling System Restore (Points)
// Sources:
//	http://msdn.microsoft.com/en-us/library/aa378951(VS.85).aspx
//	http://www.activexperts.com/activmonitor/windowsmanagement/scripts/desktop/system/
// DISCLAIMER:
//	HENK REINTS HAS WRITTEN THIS SOFWARE FOR HIS OWN USE, AS A HOBBY, WITHOUT ANY COMMERCIAL INTENTIONS.
//	IT IS PROVIDED AS IS, WITHOUT ANY GUARANTEE FOR CORRECTNESS OR USABILITY. USAGE IS AT YOUR OWN RISK.
//	IN NO WAY SHALL HENK REINTS BE LIABLE FOR ANY NEGATIVE CONSEQUENCES OF USING THIS SOFTWARE.
// #########################################################################################################

	String.prototype.ltrim		= function()	{return this.replace(/^\s+/g,"")}
	String.prototype.rtrim		= function()	{return this.replace(/\s+$/g,"")}
	String.prototype.lrtrim		= function()	{return this.replace(/^\s+|\s+$/g,"")}
	String.prototype.collapse	= function()	{return this.replace(/\s+/g,"")}
	String.prototype.compress	= function()	{return this.replace(/\s+/g," ")}
	String.prototype.compressTrim	= function()	{return this.replace(/\s+/g," ").replace(/^\s+|\s+$/g,"")}
	String.prototype.lpad		= function(L,p)
	{
		var x = (arguments.length > 1 ? ""+p : "")
		if (x.length == 0) x = " "
		return ((new Array(Math.ceil(L/x.length)+1)).join(x)+this).slice(-Math.max(this.length,L))
	}
	String.prototype.rpad		= function(L,p)
	{
		var x = (arguments.length > 1 ? ""+p : "")
		if (x.length == 0) x = " "
		return (this+(new Array(Math.ceil(L/x.length)+1)).join(x)).slice(0,Math.max(this.length,L))
	}
	Date.prototype.myDateString	= function()
	{
		var x = this.toDateString().compressTrim().split(" ")
		return [x[0].rpad(3),x[2].lpad(2,"0"),x[1].rpad(3),x[3].lpad(4,"0")].join(" ")
	}
	Date.prototype.myDateTimeString	= function()
	{
		return this.myDateString() + " " + this.toTimeString().split(" ")[0]
	}
	Array.prototype.toString	= function()
	{
		return "[" + this.join(", ") + "]"
	}

// #####################################################################################################################

	var WSH = new ActiveXObject ("WScript.Shell")
	var FSO = new ActiveXObject ("Scripting.FileSystemObject")

	function setCscriptWindowProperties (argSettings)
	{
		function regWrite (path, value, deleteIt)
		{	var e, v, x
			if (deleteIt)
			{	WSH.RegDelete(path)
				for (x = false; !x; )
				{	WScript.Sleep(10)
					try {v = WSH.RegRead(path)} catch(e) {x = true}
				}
			} else
			{	WSH.RegWrite(path, value, typeof value == "number" ? "REG_DWORD" : "REG_SZ")
				for (x = false; !x; )
				{	WScript.Sleep(10)
					x = true
					try {v = WSH.RegRead(path)} catch(e) {x = false}
					if (x) x = (v == value)
		}	}	}

		var i, e, x, ok, valname, oldValue, newValue, deleteIt, deleteList = [], savedSettings = []
		var regkey = "HKCU\\Console\\%SystemRoot%_system32_cscript.exe\\"
		var mySettings =
			[[""]					// the registry key itself
			,["FaceName"        ,"Lucida Console"]	// the value names and data I like
			,["FontFamily"      ,0x00000036]
			,["FontSize"        ,0x000c0000]
			,["FontWeight"      ,0x00000190]
			,["HistoryNoDup"    ,0x00000000]
			,["QuickEdit"       ,0x00000800]
			,["ScreenBufferSize",0x00fa0084]
			,["WindowSize"      ,0x00320084]
			]
		var theSettings = (arguments.length > 0 ? argSettings : mySettings)

		for (i = 0; i < theSettings.length; i++)
		{	valname = theSettings[i][0]
			try {x = false; oldValue = WSH.RegRead(regkey+valname)} catch(e) {x = true; oldValue = ""}
			try {           newValue = theSettings[i][1]          } catch(e) {          newValue = ""}
			try {           deleteIt = theSettings[i][2]          } catch(e) {          deleteIt = false}
			if (newValue == undefined) newValue = ""
			if (deleteIt == undefined) deleteIt = false
			savedSettings.push([valname,oldValue,x])
			if (deleteIt) deleteList.push(valname)
			else regWrite(regkey+valname,newValue)
		}
		for (i = deleteList.length; (i--) > 0; regWrite(regkey+deleteList[i],"",true) );	// deletions in reverse order
		return savedSettings
	}

	function forceCscript()
	{	var e
		try {var wscrName = WScript.FullName} catch(e) {return}
		var cscript       = "cscript"
		var parentFolder  = FSO.GetParentFolderName(wscrName)
		var basename      = FSO.GetBaseName        (wscrName)
		if (basename.toLowerCase() != cscript)
		{	var cscriptCommandLine = cscript + ' "' + WScript.ScriptFullName + '"'
			var cscriptWindowProperties = setCscriptWindowProperties()
			for (var i = 0, x = ' /W="'; i < cscriptWindowProperties.length; i++)	// prepare a /W="[...]" argument to pass the
			{	x += (i > 0 ? ',' : '[')					// saved window settings to the csript exe,
				for (var j = 0; j < cscriptWindowProperties[i].length; j++)	// it will immediately reset the config
				{	x += (j > 0 ? ',' : '[')				// to the saved original once launched
					if (typeof cscriptWindowProperties[i][j] != "string")
						x +=       cscriptWindowProperties[i][j]
					else	x += "'" + cscriptWindowProperties[i][j] + "'"
				};	x += ']'
			};	x += ']"'
			cscriptCommandLine += x
			for (var i = 0; i < WScript.Arguments.length; cscriptCommandLine += ' "' + WScript.Arguments(i++) + '"');
			WSH.Run(cscriptCommandLine)
			WScript.Quit()
		} else
		{	var args = WScript.Arguments, cscriptWindowSettings = ""
			if (args.length > 0)
			{	arg = args(0)
				if (arg.slice(0,3).toUpperCase() == "/W=" && !SLASHWDONE)
				{	setCscriptWindowProperties(eval(arg.slice(3)))	// restore saved window settings
					SLASHWDONE = true
	}	}	}	}
	SLASHWDONE = false

	function htmlWrite(txt) {return; document.all.StdOut.innerHTML += txt}
	function htmlWrerr(txt) {return; document.all.StdOut.innerHTML += txt}

	function dowrite(isErrorMessage,noEndOfLine)
	{	var e, a = dowrite.caller.arguments
		for (var x = "", s = "", i = 0; i < a.length; x += s + a[i++], s = " ");
		var y = x.replace(/\s/g,"&nbsp;") + (noEndOfLine ? "" : "<br>")
		x += (noEndOfLine ? "" : "\r\n")
		if (isErrorMessage)
		{	try {WScript.StdErr.Write(x); return} catch(e) {null}
			try {htmlWrerr(y)           ; return} catch(e) {null}
		} else
		{	try {WScript.StdOut.Write(x); return} catch(e) {null}
			try {htmlWrite(y)           ; return} catch(e) {null}
	}	}
	function writeln() {dowrite(false,false)}
	function wrerrln() {dowrite(true ,false)}
	function write  () {dowrite(false,true )}
	function wrerr  () {dowrite(true ,true )}

	function ask (promptxt)
	{	var e
		try {WScript.StdErr.Write (promptxt); return WScript.StdIn.ReadLine()} catch(e) {null}
		try {var x = window.prompt(promptxt); return x} catch(e) {null}
	}

	function pauseOrNot()
	{	var doPause = true, args = WScript.Arguments
		for (var i = 0; i < args.length && args(i).charAt(0) == "/"; i++)
		{	arg = args(i).toUpperCase()
			if (arg == "/-P") doPause = false
		}
		if (doPause) ask ("\r\n\r\nPress Enter: ")
	}

	// function to format a restore point's creation time:
		function fmtDate (time)
		{	var obj = new ActiveXObject ("WbemScripting.SWbemDateTime")
			obj.Value = time
			return (new Date(Date.parse(obj.GetVarDate()))).myDateTimeString()
		}

	// function to format a restore point's creation date only:
		function fmtDateOnly (time)
		{	var obj = new ActiveXObject ("WbemScripting.SWbemDateTime")
			obj.Value = time
			return (new Date(Date.parse(obj.GetVarDate()))).myDateString()
		}

	// function to translate restore point type to textual representation
	// source: http://www.activexperts.com/activmonitor/windowsmanagement/scripts/desktop/system/
		function RPtype (n)
		{	switch (n)
			{
			case  0: return "Application installation "
			case  1: return "Application uninstall    "
			case  6: return "Restore                  "
			case  7: return "Checkpoint               "
			case 10: return "Device drive installation"
			case 11: return "First run                "
			case 12: return "Modify settings          "
			case 13: return "Cancelled operation      "
			case 14: return "Backup recovery          "
			default: return "Unknown                  "
		}	}

// #####################################################################################################################

	function listRestorePoints (noOutput)
	{	if (noOutput) {null} else forceCscript()

	// get chronological list of restore point:
		var RParray = new Array()
		var RPlist = new Enumerator(GetObject("winmgmts:root/default").InstancesOf("SystemRestore"))
		for (; !RPlist.atEnd(); RPlist.moveNext() )
		{	var RP = RPlist.item()
			with (RP) {RParray.push( [CreationTime,SequenceNumber,RestorePointType,EventType,Description] ) }
		}
		RParray.sort()	// becomes chronological since time format = yyyymmddHHnnss (plus other stuff)
		if (noOutput) return RParray

	// create headers:
		var dL = (new Date()).myDateTimeString().length
		var tL = RPtype(10).length
		var dateHeader = "Creation Time".rpad(dL)	,dateUnderL = "".rpad(dateHeader.length,"-")
		var typeHeader = "Restore Point Type".rpad(tL)	,typeUnderL = "".rpad(typeHeader.length,"-")
		var seqnHeader = "Seq.No."			,seqnUnderL = "".rpad(seqnHeader.length,"-")
		var descHeader = "Description"			,descUnderL = "".rpad(descHeader.length,"-")
		var nowHeader  = (new Date()).myDateTimeString(),nowUnderL  = "".rpad(nowHeader.length,"=")
		var RPcount    = ""+RParray.length		,RPunder    = "".rpad(RPcount.length   ,"=")

	// write the output:
		writeln("")
		writeln(nowHeader+"  --  Found "+RPcount+" System Restore Points:")
		writeln(nowUnderL+"============"+RPunder+"=======================")
		writeln("")

		writeln([seqnHeader,dateHeader,typeHeader,descHeader].join("  "))
		writeln([seqnUnderL,dateUnderL,typeUnderL,descUnderL].join("  "))

		for (var i = 0; i < RParray.length; i++)
		{	writeln(
				[(""+RParray[i][1]).lpad(seqnHeader.length)
				,fmtDate(RParray[i][0])
				,RPtype(RParray[i][2])
				,RParray[i][4]
				].join("  "))
		}
		return RParray
	}

// #####################################################################################################################

	function createRestorePoint(argDescription)
	{
	// default values:
		var defaultDescription	= "General Restore Point"
		var askDescription	= true
		var askConfirmation	= true
		var beQuiet		= false
		var isWSH		= true
		var todayOnce		= false

	// other vars, initialization:
		var description		= ""
		var e

	// parse optionally given argument (used by 'restoreSystem'):
		if (arguments.length > 0 && argDescription != "")
		{	askConfirmation = false
			askDescription  = false
			description = argDescription
		}

	// parse command line arguments:
		try {var args = WScript.Arguments} catch(e) {isWSH = false}
		if (isWSH)
		{	for (var i = 0; i < args.length && args(i).charAt(0) == "/"; i++)	// leading "/" args
			{	arg = args(i).toUpperCase()
				if (arg == "/D") askDescription  = false	// no prompt for descr, use default if necs
				if (arg == "/Y") askConfirmation = false	// do not ask confirmation to create a RP
				if (arg == "/T") todayOnce       = true		// no new RP if today already done
				if (arg == "/Q") beQuiet         = true
			}
			for (; i < args.length; description += args(i++)+" ");	// rest of args go all into description
			description = description.compressTrim()
		} else if (askConfirmation || askDescription) return 1

	// list available restore points if in interactive mode:
		if (askConfirmation || (askDescription && (description == "") ) || todayOnce)
		{	if (!beQuiet) forceCscript()
			var RPlist = listRestorePoints(beQuiet)
			writeln("")
			if (todayOnce)
			{	var today = (new Date()).myDateString()
				for (var i = RPlist.length; (i--) > 0; )
				{	if (fmtDateOnly(RPlist[i][0]) == today)
					{	wrerrln("A Restore Point has already been created today ("+today+")\r\nNo new Restore Point created")
						return 1
		}	}	}	}

	// optionally ask confirmation:
		if (askConfirmation)
		{	var input = ask('Create new Restore Point? ').toUpperCase()
			if (input != "Y")
			{	wrerrln ("No Restore Point created")
				return 1
			}
		}

	// optionally ask description:
		if (askDescription && (description == "") )
		{	var description = ask ('Enter Restore Point Description: ')
		}

	// compress descr and optionally apply default:
		description = description.compressTrim()
		if (description == "") description = defaultDescription

	// create the Restore Point:
		wrerrln('Creating Restore Point\r\n"'+description+'"\r\nPlease Wait...')
		var SRobject = GetObject("winmgmts:{impersonationLevel=impersonate}!root/default:SystemRestore")
		var SRstatus = SRobject.CreateRestorePoint(description,7,100)

	// list result:
		listRestorePoints()

	// handle return status:
		var txt = (SRstatus != 0 ? 'Failed to create' : 'Successfully created') + ' Restore Point "' + description + '"'
		wrerrln("\r\n"+txt)
		if (SRstatus != 0) try {alert(txt)} catch(e) {null}
		return SRstatus
	}

// #####################################################################################################################

	function restoreSystem (seqno)
	{	forceCscript()

		var input = "?"
		var seqnoToRestore = NaN
		var RParray,e
		var noOutput = true

		if (arguments.length > 0)
		{	RParray = listRestorePoints(noOutput)
			for (var i = 0, k = -1; i < RParray.length; i++)
			{	if (RParray[i][1] == seqno)
				{	seqnoToRestore = RParray[i][1]
					k = i
			}	}
			if (!isFinite(seqnoToRestore)) return 1
		}
		while (!isFinite(seqnoToRestore))
		{	if (input == "?") RParray = listRestorePoints()
			writeln("")
			input = ask("Enter Seq.No. of Point to be Restored (X = exit, ? = show list): ")
			if (input.toUpperCase() == "X")
			{	wrerrln ("System Not Restored")
				return 1
			} else if (input == "?")
			{	writeln("")
			} else
			{	for (var i = 0, k = -1; i < RParray.length && k < 0; i++)
				{	if (""+RParray[i][1] == input) k = i
				}
				if (k < 0)
				{	wrerrln ('Restore Point "' + input + '" does not exist.')
				} else
				{	seqnoToRestore = RParray[k][1]
		}	}	}

		wrerrln('Starting System Restore to #'+seqnoToRestore+' = "' + fmtDate(RParray[k][0]) + ' ' + RParray[k][4] + '"')

		var SRobject = GetObject("winmgmts:{impersonationLevel=impersonate}!root/default:SystemRestore")
		var SRstatus = SRobject.Restore(seqnoToRestore)

		var txt = 'Initialisation of System Restore to Seq.No. "' + seqnoToRestore +
			(SRstatus != 0
			? '" failed.\r\n\r\nNevertheless, the computer will now be restarted'
			: '" was successful.\r\n\r\nThe computer will now be restarted'
			)
		try {WScript.Sleep(1); wrerrln(""); ask(txt + ', press Enter: ') } catch(e) {alert(txt + '.') }

		var OpSysSet = GetObject("winmgmts:{(Shutdown)}//./root/cimv2").ExecQuery("select * from Win32_OperatingSystem where Primary=true")
		for (var OSlist = new Enumerator(OpSysSet); !OSlist.atEnd(); OSlist.moveNext() )
		{	var OpSys = OSlist.item()
			OpSys.Reboot()
	}	}
